Regenerated: autoconf sysdeps/unix/sysv/linux/configure.in
[kopensolaris-gnu/glibc.git] / sysdeps / unix / sysv / linux / configure
1  # Local configure fragment for sysdeps/unix/sysv/linux.
2
3 # The Linux kernel headers can be found in
4 #   /lib/modules/$(uname -r)/build/include
5 # Check whether this directory is available.
6 if test -z "$sysheaders" &&
7    test -d /lib/modules/`uname -r`/build/include; then
8   sysheaders="/lib/modules/`uname -r`/build/include"
9   ccheaders=`$CC -print-file-name=include`
10       SYSINCLUDES="-I $sysheaders"
11 fi
12
13 # Don't bother trying to generate any glue code to be compatible with the
14 # existing system library, because we are the only system library.
15 inhibit_glue=yes
16
17 if test -n "$sysheaders"; then
18   OLD_CPPFLAGS=$CPPFLAGS
19   CPPFLAGS="$CPPFLAGS $SYSINCLUDES"
20 fi
21 echo $ac_n "checking installed Linux kernel header files""... $ac_c" 1>&6
22 echo "configure:23: checking installed Linux kernel header files" >&5
23 if eval "test \"`echo '$''{'libc_cv_linux2010'+set}'`\" = set"; then
24   echo $ac_n "(cached) $ac_c" 1>&6
25 else
26   cat > conftest.$ac_ext <<EOF
27 #line 28 "configure"
28 #include "confdefs.h"
29 #include <linux/version.h>
30 #if !defined LINUX_VERSION_CODE || LINUX_VERSION_CODE <  (2 *65536+ 0 *256+ 10) /* 2.0.10 */
31 eat flaming death
32 #endif
33 EOF
34 if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
35   egrep "eat flaming death" >/dev/null 2>&1; then
36   rm -rf conftest*
37   libc_cv_linux2010='TOO OLD!'
38 else
39   rm -rf conftest*
40   libc_cv_linux2010='2.0.10 or later'
41 fi
42 rm -f conftest*
43
44 fi
45
46 echo "$ac_t""$libc_cv_linux2010" 1>&6
47 if test "$libc_cv_linux2010" != '2.0.10 or later'; then
48   { echo "configure: error: GNU libc requires kernel header files from
49 Linux 2.0.10 or later to be installed before configuring.
50 The kernel header files are found usually in /usr/include/asm and
51 /usr/include/linux; make sure these directories use files from
52 Linux 2.0.10 or later.  This check uses <linux/version.h>, so
53 make sure that file was built correctly when installing the kernel header
54 files.  To use kernel headers not from /usr/include/linux, use the
55 configure option --with-headers." 1>&2; exit 1; }
56 fi
57
58 # If the user gave a minimal version number test whether the available
59 # kernel headers are young enough.  Additionally we have minimal
60 # kernel versions for some architectures.
61 case "$machine" in
62   alpha*)
63     arch_minimum_kernel=2.1.100
64     libc_cv_gcc_unwind_find_fde=yes
65     ;;
66   arm*)
67     arch_minimum_kernel=2.0.10
68     libc_cv_gcc_unwind_find_fde=yes
69     ;;
70   i386*)
71     libc_cv_gcc_unwind_find_fde=yes
72     arch_minimum_kernel=2.0.10
73     ;;
74   ia64*)
75     arch_minimum_kernel=2.4.0
76     ;;
77   hppa*)
78     arch_minimum_kernel=2.3.99
79     ;;
80   m68k*)
81     arch_minimum_kernel=2.0.10
82     libc_cv_gcc_unwind_find_fde=yes
83     ;;
84   mips*)
85     arch_minimum_kernel=2.4.0
86     libc_cv_gcc_unwind_find_fde=yes
87     ;;
88   powerpc/powerpc32)
89     libc_cv_gcc_unwind_find_fde=yes
90     arch_minimum_kernel=2.0.10
91     ;;
92   powerpc/powerpc64)
93     arch_minimum_kernel=2.4.19
94     ;;
95   s390/s390-32)
96     libc_cv_gcc_unwind_find_fde=yes
97     arch_minimum_kernel=2.2.10
98     ;;
99   s390/s390-64)
100     libc_cv_gcc_unwind_find_fde=yes
101     arch_minimum_kernel=2.4.0
102     ;;
103   sh*)
104     arch_minimum_kernel=2.3.99
105     libc_cv_gcc_unwind_find_fde=yes
106     ;;
107   sparc*)
108     libc_cv_gcc_unwind_find_fde=yes
109     arch_minimum_kernel=2.0.10
110     ;;
111   x86_64*)
112     arch_minimum_kernel=2.4.0
113     ;;
114   *)
115     arch_minimum_kernel=2.0.10
116     ;;
117 esac
118 if test -n "$minimum_kernel"; then
119   
120   user_version=$((`echo "$minimum_kernel.0.0.0" | sed 's/\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\).*/\1 \* 65536 + \2 \* 256 + \3/'`))
121   arch_version=$((`echo "$arch_minimum_kernel.0.0.0" | sed 's/\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\).*/\1 \* 65536 + \2 \* 256 + \3/'`))
122   
123   if test $user_version -lt $arch_version; then
124     echo "configure: warning: minimum kernel version reset to $arch_minimum_kernel" 1>&2
125     minimum_kernel=$arch_minimum_kernel
126   fi
127 else
128   if test $arch_minimum_kernel != '2.0.10'; then
129     minimum_kernel=$arch_minimum_kernel
130   fi
131 fi
132
133 if test -n "$minimum_kernel"; then
134   echo $ac_n "checking for kernel header at least $minimum_kernel""... $ac_c" 1>&6
135 echo "configure:136: checking for kernel header at least $minimum_kernel" >&5
136   decnum=`echo "$minimum_kernel.0.0.0" | sed 's/\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\).*/(\1 * 65536 + \2 * 256 + \3)/'`;
137   abinum=`echo "$minimum_kernel.0.0.0" | sed 's/\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\).*/\1,\2,\3/'`;
138   cat > conftest.$ac_ext <<EOF
139 #line 140 "configure"
140 #include "confdefs.h"
141 #include <linux/version.h>
142 #if LINUX_VERSION_CODE < $decnum
143 eat flaming death
144 #endif
145 EOF
146 if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
147   egrep "eat flaming death" >/dev/null 2>&1; then
148   rm -rf conftest*
149   libc_minimum_kernel='too old!'
150 else
151   rm -rf conftest*
152   libc_minimum_kernel=ok
153 fi
154 rm -f conftest*
155
156   echo "$ac_t""$libc_minimum_kernel" 1>&6
157   if test "$libc_minimum_kernel" = ok; then
158     cat >> confdefs.h <<EOF
159 #define __LINUX_KERNEL_VERSION $decnum
160 EOF
161
162     cat >> confdefs.h <<EOF
163 #define __ABI_TAG_VERSION $abinum
164 EOF
165
166   else
167     { echo "configure: error: *** The available kernel headers are older than the requested
168 *** compatible kernel version" 1>&2; exit 1; }
169   fi
170 fi
171
172 # The result of the above test for the use of the FDE code is invalid if
173 # the user overrides the decision about the minimum ABI.
174 if test "$oldest_abi" != default && test "2.2.4" \< "$oldest_abi"; then
175   libc_cv_gcc_unwind_find_fde=no
176 fi
177
178 if test -n "$sysheaders"; then
179   CPPFLAGS=$OLD_CPPFLAGS
180 fi
181 # The Linux filesystem standard prescribes where to place "essential"
182 # files.  I.e., when the installation prefix is "/usr" we have to place
183 # shared library objects and the configuration files on the root partition
184 # in /lib and /etc.
185 if test "$prefix" = "/usr" -o "$prefix" = "/usr/"; then
186   # 64bit libraries on sparc go to /lib64 and not /lib
187   if test "$machine" = "sparc/sparc64" -o "$machine" = "x86_64" \
188           -o "$machine" = "powerpc/powerpc64"; then
189     libc_cv_slibdir="/lib64"
190     if test "$libdir" = '${exec_prefix}/lib'; then
191       libdir='${exec_prefix}/lib64';
192       # Locale data can be shared between 32bit and 64bit libraries
193       libc_cv_localedir='${exec_prefix}/lib/locale'
194     fi
195   else
196     libc_cv_slibdir="/lib"
197   fi
198   # Allow the user to override the path with --sysconfdir
199   if test $sysconfdir = '${prefix}/etc'; then
200     libc_cv_sysconfdir=/etc
201   else
202     libc_cv_sysconfdir=$sysconfdir
203    fi
204   libc_cv_rootsbindir="/sbin"
205 fi
206
207 # Under Linux the LinuxThreads add-on should be available.
208 case $add_ons in
209   # It is available.  Good.
210   *linuxthreads*)
211     linuxthreads_missing=
212     ;;
213   *)
214     linuxthreads_missing=yes
215     ;;
216 esac
217
218 if test "$linuxthreads_missing"; then
219   if test $enable_sanity = yes; then
220     echo "\
221 *** On GNU/Linux systems it is normal to compile GNU libc with the
222 *** \`linuxthreads' add-on.  Without that, the library will be
223 *** incompatible with normal GNU/Linux systems.
224 *** If you really mean to not use this add-on, run configure again
225 *** using the extra parameter \`--disable-sanity-checks'."
226     exit 1
227   else
228     echo "\
229 *** WARNING: Are you sure you do not want to use the \`linuxthreads'
230 *** add-on?"
231   fi
232 fi
233
234 if test "$prefix" = "/usr/local" -o "$prefix" = "/usr/local/" -o "$prefix" = "NONE"; then
235   if test $enable_sanity = yes; then
236     echo "\
237 *** On GNU/Linux systems the GNU C Library should not be installed into
238 *** /usr/local since this might make your system totally unusable.
239 *** We strongly advise to use a different prefix.  For details read the FAQ.
240 *** If you really mean to do this, run configure again using the extra
241 *** parameter \`--disable-sanity-checks'."
242     exit 1
243   else
244     echo "\
245 *** WARNING: Do you really want to install the GNU C Library into /usr/local?
246 *** This might make your system totally unusable, for details read the FAQ."
247   fi
248 fi
249
250
251 # One Linux we use ldconfig.
252 use_ldconfig=yes
253
254 # We need some extensions to the `ldd' script.
255
256 case "$machine" in
257   i[3456]86* | m68*)
258     ldd_rewrite_script=../sysdeps/unix/sysv/linux/ldd-rewrite.sed
259     ;;
260   ia64*)
261     ldd_rewrite_script=../sysdeps/unix/sysv/linux/ia64/ldd-rewrite.sed
262     ;;
263   s390*)
264     ldd_rewrite_script=../sysdeps/unix/sysv/linux/s390/ldd-rewrite.sed
265     ;;
266   sparc*)
267     ldd_rewrite_script=../sysdeps/unix/sysv/linux/sparc/ldd-rewrite.sed
268     ;;
269   x86_64*)
270     ldd_rewrite_script=../sysdeps/unix/sysv/linux/x86_64/ldd-rewrite.sed
271     ;;
272   powerpc*)
273     ldd_rewrite_script=../sysdeps/unix/sysv/linux/powerpc/ldd-rewrite.sed
274     ;;
275   *)
276     ;;
277 esac
278
279
280 if test $host = $build; then
281   # If $prefix/include/{net,scsi} are symlinks, make install will
282   # clobber what they're linked to (probably a kernel tree).
283   # test -L ought to work on all Linux boxes.
284   if test "x$prefix" != xNONE; then
285     ac_prefix=$prefix
286   else
287     ac_prefix=$ac_default_prefix
288   fi
289   echo $ac_n "checking for symlinks in ${ac_prefix}/include""... $ac_c" 1>&6
290 echo "configure:291: checking for symlinks in ${ac_prefix}/include" >&5
291   ac_message=
292   if test -L ${ac_prefix}/include/net; then
293     ac_message="$ac_message
294    ${ac_prefix}/include/net is a symlink"
295   fi
296   if test -L ${ac_prefix}/include/scsi; then
297     ac_message="$ac_message
298    ${ac_prefix}/include/scsi is a symlink"
299   fi
300   if test -n "$ac_message"; then
301     { echo "configure: error: $ac_message
302 \`make install' will destroy the target of the link(s).
303 Delete the links and re-run configure, or better still, move the entire
304 ${ac_prefix}/include directory out of the way." 1>&2; exit 1; }
305   else
306     echo "$ac_t""ok" 1>&6
307   fi
308 fi